
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
    
    <head>
	<link rel="stylesheet" type="text/css" href="default.css">
	<title>Bob Overview</title>
    </head>

    <div class="spacer-line">
	&nbsp;
    </div>
    
	
	
    <a href="overview.html"><img src="bob-logo.png" /></a>
    
    <div class="titlebox" >

	<div class="topleft" >
	    <div class="topright" >
		&nbsp;
	    </div>
	</div>
	
	<!--<div class="testing">
	-->
	<div class="titleboxbody">
	    <div class="testing" >
		<a class="nav" href="api/index.html" >api</a>
		<a class="nav" href="usage.html" >usage</a>
		<a class="nav" href="arch.html" >architecture</a>
	    </div>
	</div>
    </div>
    
    <div class="spacer-line"> &nbsp; </div>

    <div class="mainbox" >

	<div class="topleft" >
	    <div class="topright" >
		&nbsp;
	    </div>
	</div>

	<div class="mainboxbody" >

<!-- OVERVIEW section
-->
<p><b>OVERVIEW:</b>
<br/><br/>

'Bob' is an XML/Java Data Binding tool. 'Bob' provides a convenient way to bind XML definitions to object representations. It is an excellent tool for:
<ol>
    <li>application prototyping</li>
    <li>rapid application development</li>
    <li>easily handling large amounts of xml data</li>
</ol>

The idea is to map out your business objects in xml. Xml tags with matching names and namespaces can be mentioned across many documents and still represent the same business object. There are some articles that go into the utility and features if Data Binding tools:
<ul>
    <li><a href="http://www.xml.com/pub/a/2003/09/03/binding.html">http://www.xml.com/pub/a/2003/09/03/binding.html</a>
    </li>
    <li><a href="http://www-106.ibm.com/developerworks/library/x-databdopt/index.html">http://www-106.ibm.com/developerworks/library/x-databdopt/index.html</a></li>
    <li><a href="http://www.rpbourret.com/xml/XMLDataBinding.htm">http://www.rpbourret.com/xml/XMLDataBinding.htm</a></li>
</ul>
</p>
<br/><br/>

<!-- FEATURES section
-->
<p><b>FEATURES:</b>
<br/><br/>

<ol>
    <li>Define objects in many documents. The definition set is generated from multiple documents. The same tag & namespace is part of same definition across documents</li>
    <li>Write objects out with 'toXML()'.</li>
</ol>
</p>
<br/><br/>


<p><b>USAGE:</b>
<br/><br/>
    
    java -classpath $CP com.interrupt.bob.Main $xml_files<br/><br/>
    
    options:<br/>
	gen - directory in which to put generated documents (deafult: gen)<br/>
	base - the base directory from which to run 'bob'   (default: .)<br/>
	end - select xml files with a given suffix	    (default: .xml)<br/>
	<br/>
	ex) <br/>
	java -classpath $CP com.interrupt.bob.Main -gen gen/ -base . -end xml $xml_files<br/>
</p>
<br/><br/>


<p><b>DOWNLOAD:</b>
<br/><br/>

Get all files from the the 'Bob' homepage in the download section:
<a href="http://sourceforge.net/projects/bob/"><b>http://sourceforge.net/projects/bob/</b></a>
<ul>
    <li>bob.jar</li>
    <li>bob-src.jar</li>
    <li>Anonymous CVS (When prompted for a password for <i>anonymous</i>):<br/>
    <b>cvs -d:pserver:anonymous@cvs.sourceforge.net:/cvsroot/bob login</b>
    <b>cvs -z3 -d:pserver:anonymous@cvs.sourceforge.net:/cvsroot/bob co -P BOBJava</b>
    </li>
</ul>

</p>
<br/><br/>


<p><b>LIBRARY DEPENDANCIES:</b>
<br/><br/>

These are runtime library dependencies:
    <ul>
	<li>Piccolo.jar (<a href="http://piccolo.sourceforge.net/">http://piccolo.sourceforge.net/</a>)</li>
	<li>commons-cli-1.0.jar (<a href="http://jakarta.apache.org/commons/cli/">http://jakarta.apache.org/commons/cli/</a>)</li>
	<li>javafind.jar (<a href="http://sourceforge.net/projects/javafind/">http://sourceforge.net/projects/javafind/</a>)</li>
	<li>velocity-1.3.1.jar (<a href="http://jakarta.apache.org/velocity/">http://jakarta.apache.org/velocity/</a>)</li>
	<li>velocity-dep-1.3.1.jar</li>
    </ul>

<br/>
And junit is needed to compile the thing:
    <ul>
	<li>junit.jar (<a href="http://www.junit.org">http://www.junit.org</a>)</li>
    </ul>
</p>
<br/><br/>


<p><b>ISSUES:</b>
<br/><br/>

<ol>
    <li>Xml tag attributes cannot have dashes in their names. There is an xml/java naming mismatch where java variables cannot have dashes in their names. This will be solved by inserting a simple translation layer to remove illegal characters for java names, then inserting them when writing toXML().
    </li>
</ol>
</p>
<br/><br/>
	    </p>
	</div>
    </div>
<br/><br/>
    
    
</html>


